# coding: utf-8

"""
    Binance COIN-M Futures API

    OpenAPI specification for Binance exchange - Cmfutures API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from binance.derivatives.cmfutures.models.cmfutures_get_account_v1_resp_assets_inner import CmfuturesGetAccountV1RespAssetsInner
from binance.derivatives.cmfutures.models.cmfutures_get_account_v1_resp_positions_inner import CmfuturesGetAccountV1RespPositionsInner
from typing import Optional, Set
from typing_extensions import Self

class CmfuturesGetAccountV1Resp(BaseModel):
    """
    CmfuturesGetAccountV1Resp
    """ # noqa: E501
    assets: Optional[List[CmfuturesGetAccountV1RespAssetsInner]] = None
    can_deposit: Optional[StrictBool] = Field(default=None, alias="canDeposit")
    can_trade: Optional[StrictBool] = Field(default=None, alias="canTrade")
    can_withdraw: Optional[StrictBool] = Field(default=None, alias="canWithdraw")
    fee_tier: Optional[StrictInt] = Field(default=None, alias="feeTier")
    positions: Optional[List[CmfuturesGetAccountV1RespPositionsInner]] = None
    update_time: Optional[StrictInt] = Field(default=None, alias="updateTime")
    __properties: ClassVar[List[str]] = ["assets", "canDeposit", "canTrade", "canWithdraw", "feeTier", "positions", "updateTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CmfuturesGetAccountV1Resp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assets (list)
        _items = []
        if self.assets:
            for _item_assets in self.assets:
                if _item_assets:
                    _items.append(_item_assets.to_dict())
            _dict['assets'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in positions (list)
        _items = []
        if self.positions:
            for _item_positions in self.positions:
                if _item_positions:
                    _items.append(_item_positions.to_dict())
            _dict['positions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CmfuturesGetAccountV1Resp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assets": [CmfuturesGetAccountV1RespAssetsInner.from_dict(_item) for _item in obj["assets"]] if obj.get("assets") is not None else None,
            "canDeposit": obj.get("canDeposit"),
            "canTrade": obj.get("canTrade"),
            "canWithdraw": obj.get("canWithdraw"),
            "feeTier": obj.get("feeTier"),
            "positions": [CmfuturesGetAccountV1RespPositionsInner.from_dict(_item) for _item in obj["positions"]] if obj.get("positions") is not None else None,
            "updateTime": obj.get("updateTime")
        })
        return _obj


