# coding: utf-8

"""
    Binance Options API

    OpenAPI specification for Binance exchange - Options API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from binance.derivatives.options.models.options_get_exchange_info_v1_resp_option_assets_inner import OptionsGetExchangeInfoV1RespOptionAssetsInner
from binance.derivatives.options.models.options_get_exchange_info_v1_resp_option_contracts_inner import OptionsGetExchangeInfoV1RespOptionContractsInner
from binance.derivatives.options.models.options_get_exchange_info_v1_resp_option_symbols_inner import OptionsGetExchangeInfoV1RespOptionSymbolsInner
from binance.derivatives.options.models.options_get_exchange_info_v1_resp_rate_limits_inner import OptionsGetExchangeInfoV1RespRateLimitsInner
from typing import Optional, Set
from typing_extensions import Self

class OptionsGetExchangeInfoV1Resp(BaseModel):
    """
    OptionsGetExchangeInfoV1Resp
    """ # noqa: E501
    option_assets: Optional[List[OptionsGetExchangeInfoV1RespOptionAssetsInner]] = Field(default=None, alias="optionAssets")
    option_contracts: Optional[List[OptionsGetExchangeInfoV1RespOptionContractsInner]] = Field(default=None, alias="optionContracts")
    option_symbols: Optional[List[OptionsGetExchangeInfoV1RespOptionSymbolsInner]] = Field(default=None, alias="optionSymbols")
    rate_limits: Optional[List[OptionsGetExchangeInfoV1RespRateLimitsInner]] = Field(default=None, alias="rateLimits")
    server_time: Optional[StrictInt] = Field(default=None, alias="serverTime")
    timezone: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["optionAssets", "optionContracts", "optionSymbols", "rateLimits", "serverTime", "timezone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OptionsGetExchangeInfoV1Resp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in option_assets (list)
        _items = []
        if self.option_assets:
            for _item_option_assets in self.option_assets:
                if _item_option_assets:
                    _items.append(_item_option_assets.to_dict())
            _dict['optionAssets'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in option_contracts (list)
        _items = []
        if self.option_contracts:
            for _item_option_contracts in self.option_contracts:
                if _item_option_contracts:
                    _items.append(_item_option_contracts.to_dict())
            _dict['optionContracts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in option_symbols (list)
        _items = []
        if self.option_symbols:
            for _item_option_symbols in self.option_symbols:
                if _item_option_symbols:
                    _items.append(_item_option_symbols.to_dict())
            _dict['optionSymbols'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in rate_limits (list)
        _items = []
        if self.rate_limits:
            for _item_rate_limits in self.rate_limits:
                if _item_rate_limits:
                    _items.append(_item_rate_limits.to_dict())
            _dict['rateLimits'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OptionsGetExchangeInfoV1Resp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "optionAssets": [OptionsGetExchangeInfoV1RespOptionAssetsInner.from_dict(_item) for _item in obj["optionAssets"]] if obj.get("optionAssets") is not None else None,
            "optionContracts": [OptionsGetExchangeInfoV1RespOptionContractsInner.from_dict(_item) for _item in obj["optionContracts"]] if obj.get("optionContracts") is not None else None,
            "optionSymbols": [OptionsGetExchangeInfoV1RespOptionSymbolsInner.from_dict(_item) for _item in obj["optionSymbols"]] if obj.get("optionSymbols") is not None else None,
            "rateLimits": [OptionsGetExchangeInfoV1RespRateLimitsInner.from_dict(_item) for _item in obj["rateLimits"]] if obj.get("rateLimits") is not None else None,
            "serverTime": obj.get("serverTime"),
            "timezone": obj.get("timezone")
        })
        return _obj


