# coding: utf-8

"""
    Binance Options API

    OpenAPI specification for Binance exchange - Options API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OptionsGetTickerV1RespItem(BaseModel):
    """
    OptionsGetTickerV1RespItem
    """ # noqa: E501
    amount: Optional[StrictStr] = None
    ask_price: Optional[StrictStr] = Field(default=None, alias="askPrice")
    bid_price: Optional[StrictStr] = Field(default=None, alias="bidPrice")
    close_time: Optional[StrictInt] = Field(default=None, alias="closeTime")
    exercise_price: Optional[StrictStr] = Field(default=None, alias="exercisePrice")
    first_trade_id: Optional[StrictInt] = Field(default=None, alias="firstTradeId")
    high: Optional[StrictStr] = None
    last_price: Optional[StrictStr] = Field(default=None, alias="lastPrice")
    last_qty: Optional[StrictStr] = Field(default=None, alias="lastQty")
    low: Optional[StrictStr] = None
    open: Optional[StrictStr] = None
    open_time: Optional[StrictInt] = Field(default=None, alias="openTime")
    price_change: Optional[StrictStr] = Field(default=None, alias="priceChange")
    price_change_percent: Optional[StrictStr] = Field(default=None, alias="priceChangePercent")
    strike_price: Optional[StrictStr] = Field(default=None, alias="strikePrice")
    symbol: Optional[StrictStr] = None
    trade_count: Optional[StrictInt] = Field(default=None, alias="tradeCount")
    volume: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["amount", "askPrice", "bidPrice", "closeTime", "exercisePrice", "firstTradeId", "high", "lastPrice", "lastQty", "low", "open", "openTime", "priceChange", "priceChangePercent", "strikePrice", "symbol", "tradeCount", "volume"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OptionsGetTickerV1RespItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OptionsGetTickerV1RespItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "askPrice": obj.get("askPrice"),
            "bidPrice": obj.get("bidPrice"),
            "closeTime": obj.get("closeTime"),
            "exercisePrice": obj.get("exercisePrice"),
            "firstTradeId": obj.get("firstTradeId"),
            "high": obj.get("high"),
            "lastPrice": obj.get("lastPrice"),
            "lastQty": obj.get("lastQty"),
            "low": obj.get("low"),
            "open": obj.get("open"),
            "openTime": obj.get("openTime"),
            "priceChange": obj.get("priceChange"),
            "priceChangePercent": obj.get("priceChangePercent"),
            "strikePrice": obj.get("strikePrice"),
            "symbol": obj.get("symbol"),
            "tradeCount": obj.get("tradeCount"),
            "volume": obj.get("volume")
        })
        return _obj


