# coding: utf-8

"""
    Binance USD-M Futures API

    OpenAPI specification for Binance exchange - Umfutures API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from binance.derivatives.umfutures.models.umfutures_get_account_v3_resp_assets_inner import UmfuturesGetAccountV3RespAssetsInner
from binance.derivatives.umfutures.models.umfutures_get_account_v3_resp_positions_inner import UmfuturesGetAccountV3RespPositionsInner
from typing import Optional, Set
from typing_extensions import Self

class UmfuturesGetAccountV3Resp(BaseModel):
    """
    UmfuturesGetAccountV3Resp
    """ # noqa: E501
    assets: Optional[List[UmfuturesGetAccountV3RespAssetsInner]] = None
    available_balance: Optional[StrictStr] = Field(default=None, alias="availableBalance")
    max_withdraw_amount: Optional[StrictStr] = Field(default=None, alias="maxWithdrawAmount")
    positions: Optional[List[UmfuturesGetAccountV3RespPositionsInner]] = None
    total_cross_un_pnl: Optional[StrictStr] = Field(default=None, alias="totalCrossUnPnl")
    total_cross_wallet_balance: Optional[StrictStr] = Field(default=None, alias="totalCrossWalletBalance")
    total_initial_margin: Optional[StrictStr] = Field(default=None, alias="totalInitialMargin")
    total_maint_margin: Optional[StrictStr] = Field(default=None, alias="totalMaintMargin")
    total_margin_balance: Optional[StrictStr] = Field(default=None, alias="totalMarginBalance")
    total_open_order_initial_margin: Optional[StrictStr] = Field(default=None, alias="totalOpenOrderInitialMargin")
    total_position_initial_margin: Optional[StrictStr] = Field(default=None, alias="totalPositionInitialMargin")
    total_unrealized_profit: Optional[StrictStr] = Field(default=None, alias="totalUnrealizedProfit")
    total_wallet_balance: Optional[StrictStr] = Field(default=None, alias="totalWalletBalance")
    __properties: ClassVar[List[str]] = ["assets", "availableBalance", "maxWithdrawAmount", "positions", "totalCrossUnPnl", "totalCrossWalletBalance", "totalInitialMargin", "totalMaintMargin", "totalMarginBalance", "totalOpenOrderInitialMargin", "totalPositionInitialMargin", "totalUnrealizedProfit", "totalWalletBalance"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UmfuturesGetAccountV3Resp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assets (list)
        _items = []
        if self.assets:
            for _item_assets in self.assets:
                if _item_assets:
                    _items.append(_item_assets.to_dict())
            _dict['assets'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in positions (list)
        _items = []
        if self.positions:
            for _item_positions in self.positions:
                if _item_positions:
                    _items.append(_item_positions.to_dict())
            _dict['positions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UmfuturesGetAccountV3Resp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assets": [UmfuturesGetAccountV3RespAssetsInner.from_dict(_item) for _item in obj["assets"]] if obj.get("assets") is not None else None,
            "availableBalance": obj.get("availableBalance"),
            "maxWithdrawAmount": obj.get("maxWithdrawAmount"),
            "positions": [UmfuturesGetAccountV3RespPositionsInner.from_dict(_item) for _item in obj["positions"]] if obj.get("positions") is not None else None,
            "totalCrossUnPnl": obj.get("totalCrossUnPnl"),
            "totalCrossWalletBalance": obj.get("totalCrossWalletBalance"),
            "totalInitialMargin": obj.get("totalInitialMargin"),
            "totalMaintMargin": obj.get("totalMaintMargin"),
            "totalMarginBalance": obj.get("totalMarginBalance"),
            "totalOpenOrderInitialMargin": obj.get("totalOpenOrderInitialMargin"),
            "totalPositionInitialMargin": obj.get("totalPositionInitialMargin"),
            "totalUnrealizedProfit": obj.get("totalUnrealizedProfit"),
            "totalWalletBalance": obj.get("totalWalletBalance")
        })
        return _obj


