# coding: utf-8

"""
    Binance Margin Trading API

    OpenAPI specification for Binance exchange - Margin API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictInt, StrictStr
from typing import List, Optional
from typing_extensions import Annotated
from binance.margin.models.margin_create_margin_borrow_repay_v1_resp import MarginCreateMarginBorrowRepayV1Resp
from binance.margin.models.margin_get_margin_borrow_repay_v1_resp import MarginGetMarginBorrowRepayV1Resp
from binance.margin.models.margin_get_margin_interest_history_v1_resp import MarginGetMarginInterestHistoryV1Resp
from binance.margin.models.margin_get_margin_interest_rate_history_v1_resp_item import MarginGetMarginInterestRateHistoryV1RespItem
from binance.margin.models.margin_get_margin_max_borrowable_v1_resp import MarginGetMarginMaxBorrowableV1Resp
from binance.margin.models.margin_get_margin_next_hourly_interest_rate_v1_resp_item import MarginGetMarginNextHourlyInterestRateV1RespItem

from binance.margin.api_client import ApiClient, RequestSerialized
from binance.margin.api_response import ApiResponse
from binance.margin.rest import RESTResponseType


class BorrowAndRepayApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def margin_create_margin_borrow_repay_v1(
        self,
        amount: StrictStr,
        asset: StrictStr,
        is_isolated: StrictStr,
        symbol: StrictStr,
        timestamp: StrictInt,
        type: StrictStr,
        recv_window: Optional[StrictInt] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> MarginCreateMarginBorrowRepayV1Resp:
        """Margin account borrow/repay(MARGIN)

        Margin account borrow/repay(MARGIN)

        :param amount: (required)
        :type amount: str
        :param asset: (required)
        :type asset: str
        :param is_isolated: (required)
        :type is_isolated: str
        :param symbol: (required)
        :type symbol: str
        :param timestamp: (required)
        :type timestamp: int
        :param type: (required)
        :type type: str
        :param recv_window:
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_create_margin_borrow_repay_v1_serialize(
            amount=amount,
            asset=asset,
            is_isolated=is_isolated,
            symbol=symbol,
            timestamp=timestamp,
            type=type,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginCreateMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_create_margin_borrow_repay_v1_with_http_info(
        self,
        amount: StrictStr,
        asset: StrictStr,
        is_isolated: StrictStr,
        symbol: StrictStr,
        timestamp: StrictInt,
        type: StrictStr,
        recv_window: Optional[StrictInt] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[MarginCreateMarginBorrowRepayV1Resp]:
        """Margin account borrow/repay(MARGIN)

        Margin account borrow/repay(MARGIN)

        :param amount: (required)
        :type amount: str
        :param asset: (required)
        :type asset: str
        :param is_isolated: (required)
        :type is_isolated: str
        :param symbol: (required)
        :type symbol: str
        :param timestamp: (required)
        :type timestamp: int
        :param type: (required)
        :type type: str
        :param recv_window:
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_create_margin_borrow_repay_v1_serialize(
            amount=amount,
            asset=asset,
            is_isolated=is_isolated,
            symbol=symbol,
            timestamp=timestamp,
            type=type,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginCreateMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_create_margin_borrow_repay_v1_without_preload_content(
        self,
        amount: StrictStr,
        asset: StrictStr,
        is_isolated: StrictStr,
        symbol: StrictStr,
        timestamp: StrictInt,
        type: StrictStr,
        recv_window: Optional[StrictInt] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Margin account borrow/repay(MARGIN)

        Margin account borrow/repay(MARGIN)

        :param amount: (required)
        :type amount: str
        :param asset: (required)
        :type asset: str
        :param is_isolated: (required)
        :type is_isolated: str
        :param symbol: (required)
        :type symbol: str
        :param timestamp: (required)
        :type timestamp: int
        :param type: (required)
        :type type: str
        :param recv_window:
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_create_margin_borrow_repay_v1_serialize(
            amount=amount,
            asset=asset,
            is_isolated=is_isolated,
            symbol=symbol,
            timestamp=timestamp,
            type=type,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginCreateMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_create_margin_borrow_repay_v1_serialize(
        self,
        amount,
        asset,
        is_isolated,
        symbol,
        timestamp,
        type,
        recv_window,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        if amount is not None:
            _form_params.append(('amount', amount))
        if asset is not None:
            _form_params.append(('asset', asset))
        if is_isolated is not None:
            _form_params.append(('isIsolated', is_isolated))
        if recv_window is not None:
            _form_params.append(('recvWindow', recv_window))
        if symbol is not None:
            _form_params.append(('symbol', symbol))
        if timestamp is not None:
            _form_params.append(('timestamp', timestamp))
        if type is not None:
            _form_params.append(('type', type))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/sapi/v1/margin/borrow-repay',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def margin_get_margin_borrow_repay_v1(
        self,
        type: Annotated[StrictStr, Field(description="`BORROW` or `REPAY`")],
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="Symbol in Isolated Margin")] = None,
        tx_id: Annotated[Optional[StrictInt], Field(description="`tranId` in `POST /sapi/v1/margin/loan`")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Current querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> MarginGetMarginBorrowRepayV1Resp:
        """Query borrow/repay records in Margin account(USER_DATA)

        Query borrow/repay records in Margin account

        :param type: `BORROW` or `REPAY` (required)
        :type type: str
        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: Symbol in Isolated Margin
        :type isolated_symbol: str
        :param tx_id: `tranId` in `POST /sapi/v1/margin/loan`
        :type tx_id: int
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Current querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_borrow_repay_v1_serialize(
            type=type,
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            tx_id=tx_id,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_get_margin_borrow_repay_v1_with_http_info(
        self,
        type: Annotated[StrictStr, Field(description="`BORROW` or `REPAY`")],
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="Symbol in Isolated Margin")] = None,
        tx_id: Annotated[Optional[StrictInt], Field(description="`tranId` in `POST /sapi/v1/margin/loan`")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Current querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[MarginGetMarginBorrowRepayV1Resp]:
        """Query borrow/repay records in Margin account(USER_DATA)

        Query borrow/repay records in Margin account

        :param type: `BORROW` or `REPAY` (required)
        :type type: str
        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: Symbol in Isolated Margin
        :type isolated_symbol: str
        :param tx_id: `tranId` in `POST /sapi/v1/margin/loan`
        :type tx_id: int
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Current querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_borrow_repay_v1_serialize(
            type=type,
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            tx_id=tx_id,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_get_margin_borrow_repay_v1_without_preload_content(
        self,
        type: Annotated[StrictStr, Field(description="`BORROW` or `REPAY`")],
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="Symbol in Isolated Margin")] = None,
        tx_id: Annotated[Optional[StrictInt], Field(description="`tranId` in `POST /sapi/v1/margin/loan`")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Current querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Query borrow/repay records in Margin account(USER_DATA)

        Query borrow/repay records in Margin account

        :param type: `BORROW` or `REPAY` (required)
        :type type: str
        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: Symbol in Isolated Margin
        :type isolated_symbol: str
        :param tx_id: `tranId` in `POST /sapi/v1/margin/loan`
        :type tx_id: int
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Current querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_borrow_repay_v1_serialize(
            type=type,
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            tx_id=tx_id,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginBorrowRepayV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_get_margin_borrow_repay_v1_serialize(
        self,
        type,
        timestamp,
        asset,
        isolated_symbol,
        tx_id,
        start_time,
        end_time,
        current,
        size,
        recv_window,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if asset is not None:
            
            _query_params.append(('asset', asset))
            
        if isolated_symbol is not None:
            
            _query_params.append(('isolatedSymbol', isolated_symbol))
            
        if tx_id is not None:
            
            _query_params.append(('txId', tx_id))
            
        if start_time is not None:
            
            _query_params.append(('startTime', start_time))
            
        if end_time is not None:
            
            _query_params.append(('endTime', end_time))
            
        if current is not None:
            
            _query_params.append(('current', current))
            
        if size is not None:
            
            _query_params.append(('size', size))
            
        if type is not None:
            
            _query_params.append(('type', type))
            
        if recv_window is not None:
            
            _query_params.append(('recvWindow', recv_window))
            
        if timestamp is not None:
            
            _query_params.append(('timestamp', timestamp))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/sapi/v1/margin/borrow-repay',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def margin_get_margin_interest_history_v1(
        self,
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Currently querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> MarginGetMarginInterestHistoryV1Resp:
        """Get Interest History (USER_DATA)

        Get Interest History

        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Currently querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_history_v1_serialize(
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginInterestHistoryV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_get_margin_interest_history_v1_with_http_info(
        self,
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Currently querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[MarginGetMarginInterestHistoryV1Resp]:
        """Get Interest History (USER_DATA)

        Get Interest History

        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Currently querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_history_v1_serialize(
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginInterestHistoryV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_get_margin_interest_history_v1_without_preload_content(
        self,
        timestamp: StrictInt,
        asset: Optional[StrictStr] = None,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        start_time: Optional[StrictInt] = None,
        end_time: Optional[StrictInt] = None,
        current: Annotated[Optional[StrictInt], Field(description="Currently querying page. Start from 1. Default:1")] = None,
        size: Annotated[Optional[StrictInt], Field(description="Default:10 Max:100")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get Interest History (USER_DATA)

        Get Interest History

        :param timestamp: (required)
        :type timestamp: int
        :param asset:
        :type asset: str
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param start_time:
        :type start_time: int
        :param end_time:
        :type end_time: int
        :param current: Currently querying page. Start from 1. Default:1
        :type current: int
        :param size: Default:10 Max:100
        :type size: int
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_history_v1_serialize(
            timestamp=timestamp,
            asset=asset,
            isolated_symbol=isolated_symbol,
            start_time=start_time,
            end_time=end_time,
            current=current,
            size=size,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginInterestHistoryV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_get_margin_interest_history_v1_serialize(
        self,
        timestamp,
        asset,
        isolated_symbol,
        start_time,
        end_time,
        current,
        size,
        recv_window,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if asset is not None:
            
            _query_params.append(('asset', asset))
            
        if isolated_symbol is not None:
            
            _query_params.append(('isolatedSymbol', isolated_symbol))
            
        if start_time is not None:
            
            _query_params.append(('startTime', start_time))
            
        if end_time is not None:
            
            _query_params.append(('endTime', end_time))
            
        if current is not None:
            
            _query_params.append(('current', current))
            
        if size is not None:
            
            _query_params.append(('size', size))
            
        if recv_window is not None:
            
            _query_params.append(('recvWindow', recv_window))
            
        if timestamp is not None:
            
            _query_params.append(('timestamp', timestamp))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/sapi/v1/margin/interestHistory',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def margin_get_margin_interest_rate_history_v1(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        vip_level: Annotated[Optional[StrictInt], Field(description="Default: user&#39;s vip level")] = None,
        start_time: Annotated[Optional[StrictInt], Field(description="Default: 7 days ago")] = None,
        end_time: Annotated[Optional[StrictInt], Field(description="Default: present. Maximum range: 1 months.")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="No more than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> List[MarginGetMarginInterestRateHistoryV1RespItem]:
        """Query Margin Interest Rate History (USER_DATA)

        Query Margin Interest Rate History

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param vip_level: Default: user&#39;s vip level
        :type vip_level: int
        :param start_time: Default: 7 days ago
        :type start_time: int
        :param end_time: Default: present. Maximum range: 1 months.
        :type end_time: int
        :param recv_window: No more than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_rate_history_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            vip_level=vip_level,
            start_time=start_time,
            end_time=end_time,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginInterestRateHistoryV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_get_margin_interest_rate_history_v1_with_http_info(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        vip_level: Annotated[Optional[StrictInt], Field(description="Default: user&#39;s vip level")] = None,
        start_time: Annotated[Optional[StrictInt], Field(description="Default: 7 days ago")] = None,
        end_time: Annotated[Optional[StrictInt], Field(description="Default: present. Maximum range: 1 months.")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="No more than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[List[MarginGetMarginInterestRateHistoryV1RespItem]]:
        """Query Margin Interest Rate History (USER_DATA)

        Query Margin Interest Rate History

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param vip_level: Default: user&#39;s vip level
        :type vip_level: int
        :param start_time: Default: 7 days ago
        :type start_time: int
        :param end_time: Default: present. Maximum range: 1 months.
        :type end_time: int
        :param recv_window: No more than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_rate_history_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            vip_level=vip_level,
            start_time=start_time,
            end_time=end_time,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginInterestRateHistoryV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_get_margin_interest_rate_history_v1_without_preload_content(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        vip_level: Annotated[Optional[StrictInt], Field(description="Default: user&#39;s vip level")] = None,
        start_time: Annotated[Optional[StrictInt], Field(description="Default: 7 days ago")] = None,
        end_time: Annotated[Optional[StrictInt], Field(description="Default: present. Maximum range: 1 months.")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="No more than 60000")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Query Margin Interest Rate History (USER_DATA)

        Query Margin Interest Rate History

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param vip_level: Default: user&#39;s vip level
        :type vip_level: int
        :param start_time: Default: 7 days ago
        :type start_time: int
        :param end_time: Default: present. Maximum range: 1 months.
        :type end_time: int
        :param recv_window: No more than 60000
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_interest_rate_history_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            vip_level=vip_level,
            start_time=start_time,
            end_time=end_time,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginInterestRateHistoryV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_get_margin_interest_rate_history_v1_serialize(
        self,
        asset,
        timestamp,
        vip_level,
        start_time,
        end_time,
        recv_window,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if asset is not None:
            
            _query_params.append(('asset', asset))
            
        if vip_level is not None:
            
            _query_params.append(('vipLevel', vip_level))
            
        if start_time is not None:
            
            _query_params.append(('startTime', start_time))
            
        if end_time is not None:
            
            _query_params.append(('endTime', end_time))
            
        if recv_window is not None:
            
            _query_params.append(('recvWindow', recv_window))
            
        if timestamp is not None:
            
            _query_params.append(('timestamp', timestamp))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/sapi/v1/margin/interestRateHistory',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def margin_get_margin_max_borrowable_v1(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> MarginGetMarginMaxBorrowableV1Resp:
        """Query Max Borrow (USER_DATA)

        Query Max Borrow

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_max_borrowable_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            isolated_symbol=isolated_symbol,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginMaxBorrowableV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_get_margin_max_borrowable_v1_with_http_info(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[MarginGetMarginMaxBorrowableV1Resp]:
        """Query Max Borrow (USER_DATA)

        Query Max Borrow

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_max_borrowable_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            isolated_symbol=isolated_symbol,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginMaxBorrowableV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_get_margin_max_borrowable_v1_without_preload_content(
        self,
        asset: StrictStr,
        timestamp: StrictInt,
        isolated_symbol: Annotated[Optional[StrictStr], Field(description="isolated symbol")] = None,
        recv_window: Annotated[Optional[StrictInt], Field(description="The value cannot be greater than `60000`")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Query Max Borrow (USER_DATA)

        Query Max Borrow

        :param asset: (required)
        :type asset: str
        :param timestamp: (required)
        :type timestamp: int
        :param isolated_symbol: isolated symbol
        :type isolated_symbol: str
        :param recv_window: The value cannot be greater than `60000`
        :type recv_window: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_max_borrowable_v1_serialize(
            asset=asset,
            timestamp=timestamp,
            isolated_symbol=isolated_symbol,
            recv_window=recv_window,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MarginGetMarginMaxBorrowableV1Resp",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_get_margin_max_borrowable_v1_serialize(
        self,
        asset,
        timestamp,
        isolated_symbol,
        recv_window,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if asset is not None:
            
            _query_params.append(('asset', asset))
            
        if isolated_symbol is not None:
            
            _query_params.append(('isolatedSymbol', isolated_symbol))
            
        if recv_window is not None:
            
            _query_params.append(('recvWindow', recv_window))
            
        if timestamp is not None:
            
            _query_params.append(('timestamp', timestamp))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/sapi/v1/margin/maxBorrowable',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def margin_get_margin_next_hourly_interest_rate_v1(
        self,
        assets: Annotated[StrictStr, Field(description="List of assets, separated by commas, up to 20")],
        is_isolated: Annotated[StrictBool, Field(description="for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34;")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> List[MarginGetMarginNextHourlyInterestRateV1RespItem]:
        """Get future hourly interest rate (USER_DATA)

        Get future hourly interest rate

        :param assets: List of assets, separated by commas, up to 20 (required)
        :type assets: str
        :param is_isolated: for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34; (required)
        :type is_isolated: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_next_hourly_interest_rate_v1_serialize(
            assets=assets,
            is_isolated=is_isolated,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginNextHourlyInterestRateV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def margin_get_margin_next_hourly_interest_rate_v1_with_http_info(
        self,
        assets: Annotated[StrictStr, Field(description="List of assets, separated by commas, up to 20")],
        is_isolated: Annotated[StrictBool, Field(description="for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34;")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[List[MarginGetMarginNextHourlyInterestRateV1RespItem]]:
        """Get future hourly interest rate (USER_DATA)

        Get future hourly interest rate

        :param assets: List of assets, separated by commas, up to 20 (required)
        :type assets: str
        :param is_isolated: for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34; (required)
        :type is_isolated: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_next_hourly_interest_rate_v1_serialize(
            assets=assets,
            is_isolated=is_isolated,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginNextHourlyInterestRateV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def margin_get_margin_next_hourly_interest_rate_v1_without_preload_content(
        self,
        assets: Annotated[StrictStr, Field(description="List of assets, separated by commas, up to 20")],
        is_isolated: Annotated[StrictBool, Field(description="for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34;")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get future hourly interest rate (USER_DATA)

        Get future hourly interest rate

        :param assets: List of assets, separated by commas, up to 20 (required)
        :type assets: str
        :param is_isolated: for isolated margin or not, &#34;TRUE&#34;, &#34;FALSE&#34; (required)
        :type is_isolated: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._margin_get_margin_next_hourly_interest_rate_v1_serialize(
            assets=assets,
            is_isolated=is_isolated,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[MarginGetMarginNextHourlyInterestRateV1RespItem]",
            '4XX': "APIError",
            '5XX': "APIError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _margin_get_margin_next_hourly_interest_rate_v1_serialize(
        self,
        assets,
        is_isolated,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if assets is not None:
            
            _query_params.append(('assets', assets))
            
        if is_isolated is not None:
            
            _query_params.append(('isIsolated', is_isolated))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/sapi/v1/margin/next-hourly-interest-rate',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


