# coding: utf-8

"""
    Binance Spot API

    OpenAPI specification for Binance exchange - Spot API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from binance.spot.models.spot_get_exchange_info_v3_resp_exchange_filters_inner import SpotGetExchangeInfoV3RespExchangeFiltersInner
from binance.spot.models.spot_get_exchange_info_v3_resp_sors_inner import SpotGetExchangeInfoV3RespSorsInner
from binance.spot.models.spot_get_exchange_info_v3_resp_symbols_inner import SpotGetExchangeInfoV3RespSymbolsInner
from binance.spot.models.spot_rate_limit import SpotRateLimit
from typing import Optional, Set
from typing_extensions import Self

class SpotGetExchangeInfoV3Resp(BaseModel):
    """
    SpotGetExchangeInfoV3Resp
    """ # noqa: E501
    exchange_filters: Optional[List[SpotGetExchangeInfoV3RespExchangeFiltersInner]] = Field(default=None, alias="exchangeFilters")
    rate_limits: Optional[List[SpotRateLimit]] = Field(default=None, alias="rateLimits")
    server_time: Optional[StrictInt] = Field(default=None, alias="serverTime")
    sors: Optional[List[SpotGetExchangeInfoV3RespSorsInner]] = None
    symbols: Optional[List[SpotGetExchangeInfoV3RespSymbolsInner]] = None
    timezone: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["exchangeFilters", "rateLimits", "serverTime", "sors", "symbols", "timezone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SpotGetExchangeInfoV3Resp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in exchange_filters (list)
        _items = []
        if self.exchange_filters:
            for _item_exchange_filters in self.exchange_filters:
                if _item_exchange_filters:
                    _items.append(_item_exchange_filters.to_dict())
            _dict['exchangeFilters'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in rate_limits (list)
        _items = []
        if self.rate_limits:
            for _item_rate_limits in self.rate_limits:
                if _item_rate_limits:
                    _items.append(_item_rate_limits.to_dict())
            _dict['rateLimits'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sors (list)
        _items = []
        if self.sors:
            for _item_sors in self.sors:
                if _item_sors:
                    _items.append(_item_sors.to_dict())
            _dict['sors'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in symbols (list)
        _items = []
        if self.symbols:
            for _item_symbols in self.symbols:
                if _item_symbols:
                    _items.append(_item_symbols.to_dict())
            _dict['symbols'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SpotGetExchangeInfoV3Resp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "exchangeFilters": [SpotGetExchangeInfoV3RespExchangeFiltersInner.from_dict(_item) for _item in obj["exchangeFilters"]] if obj.get("exchangeFilters") is not None else None,
            "rateLimits": [SpotRateLimit.from_dict(_item) for _item in obj["rateLimits"]] if obj.get("rateLimits") is not None else None,
            "serverTime": obj.get("serverTime"),
            "sors": [SpotGetExchangeInfoV3RespSorsInner.from_dict(_item) for _item in obj["sors"]] if obj.get("sors") is not None else None,
            "symbols": [SpotGetExchangeInfoV3RespSymbolsInner.from_dict(_item) for _item in obj["symbols"]] if obj.get("symbols") is not None else None,
            "timezone": obj.get("timezone")
        })
        return _obj


