# coding: utf-8

"""
    Binance Spot API

    OpenAPI specification for Binance exchange - Spot API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SpotSymbolFilter(BaseModel):
    """
    SpotSymbolFilter
    """ # noqa: E501
    apply_max_to_market: Optional[StrictBool] = Field(default=None, alias="applyMaxToMarket")
    apply_min_to_market: Optional[StrictBool] = Field(default=None, alias="applyMinToMarket")
    apply_to_market: Optional[StrictBool] = Field(default=None, alias="applyToMarket")
    ask_multiplier_down: Optional[StrictStr] = Field(default=None, alias="askMultiplierDown")
    ask_multiplier_up: Optional[StrictStr] = Field(default=None, alias="askMultiplierUp")
    avg_price_mins: Optional[StrictInt] = Field(default=None, alias="avgPriceMins")
    bid_multiplier_down: Optional[StrictStr] = Field(default=None, alias="bidMultiplierDown")
    bid_multiplier_up: Optional[StrictStr] = Field(default=None, alias="bidMultiplierUp")
    filter_type: Optional[StrictStr] = Field(default=None, alias="filterType")
    limit: Optional[StrictInt] = None
    max_notional_value: Optional[StrictStr] = Field(default=None, alias="maxNotionalValue")
    max_num_algo_orders: Optional[StrictInt] = Field(default=None, alias="maxNumAlgoOrders")
    max_num_iceberg_orders: Optional[StrictInt] = Field(default=None, alias="maxNumIcebergOrders")
    max_num_orders: Optional[StrictInt] = Field(default=None, alias="maxNumOrders")
    max_position: Optional[StrictStr] = Field(default=None, alias="maxPosition")
    max_price: Optional[StrictStr] = Field(default=None, alias="maxPrice")
    max_qty: Optional[StrictStr] = Field(default=None, alias="maxQty")
    max_trailing_above_delta: Optional[StrictInt] = Field(default=None, alias="maxTrailingAboveDelta")
    max_trailing_below_delta: Optional[StrictInt] = Field(default=None, alias="maxTrailingBelowDelta")
    min_notional_value: Optional[StrictStr] = Field(default=None, alias="minNotionalValue")
    min_price: Optional[StrictStr] = Field(default=None, alias="minPrice")
    min_qty: Optional[StrictStr] = Field(default=None, alias="minQty")
    min_trailing_above_delta: Optional[StrictInt] = Field(default=None, alias="minTrailingAboveDelta")
    min_trailing_below_delta: Optional[StrictInt] = Field(default=None, alias="minTrailingBelowDelta")
    multiplier_down: Optional[StrictStr] = Field(default=None, alias="multiplierDown")
    multiplier_up: Optional[StrictStr] = Field(default=None, alias="multiplierUp")
    step_size: Optional[StrictStr] = Field(default=None, alias="stepSize")
    tick_size: Optional[StrictStr] = Field(default=None, alias="tickSize")
    __properties: ClassVar[List[str]] = ["applyMaxToMarket", "applyMinToMarket", "applyToMarket", "askMultiplierDown", "askMultiplierUp", "avgPriceMins", "bidMultiplierDown", "bidMultiplierUp", "filterType", "limit", "maxNotionalValue", "maxNumAlgoOrders", "maxNumIcebergOrders", "maxNumOrders", "maxPosition", "maxPrice", "maxQty", "maxTrailingAboveDelta", "maxTrailingBelowDelta", "minNotionalValue", "minPrice", "minQty", "minTrailingAboveDelta", "minTrailingBelowDelta", "multiplierDown", "multiplierUp", "stepSize", "tickSize"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SpotSymbolFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SpotSymbolFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "applyMaxToMarket": obj.get("applyMaxToMarket"),
            "applyMinToMarket": obj.get("applyMinToMarket"),
            "applyToMarket": obj.get("applyToMarket"),
            "askMultiplierDown": obj.get("askMultiplierDown"),
            "askMultiplierUp": obj.get("askMultiplierUp"),
            "avgPriceMins": obj.get("avgPriceMins"),
            "bidMultiplierDown": obj.get("bidMultiplierDown"),
            "bidMultiplierUp": obj.get("bidMultiplierUp"),
            "filterType": obj.get("filterType"),
            "limit": obj.get("limit"),
            "maxNotionalValue": obj.get("maxNotionalValue"),
            "maxNumAlgoOrders": obj.get("maxNumAlgoOrders"),
            "maxNumIcebergOrders": obj.get("maxNumIcebergOrders"),
            "maxNumOrders": obj.get("maxNumOrders"),
            "maxPosition": obj.get("maxPosition"),
            "maxPrice": obj.get("maxPrice"),
            "maxQty": obj.get("maxQty"),
            "maxTrailingAboveDelta": obj.get("maxTrailingAboveDelta"),
            "maxTrailingBelowDelta": obj.get("maxTrailingBelowDelta"),
            "minNotionalValue": obj.get("minNotionalValue"),
            "minPrice": obj.get("minPrice"),
            "minQty": obj.get("minQty"),
            "minTrailingAboveDelta": obj.get("minTrailingAboveDelta"),
            "minTrailingBelowDelta": obj.get("minTrailingBelowDelta"),
            "multiplierDown": obj.get("multiplierDown"),
            "multiplierUp": obj.get("multiplierUp"),
            "stepSize": obj.get("stepSize"),
            "tickSize": obj.get("tickSize")
        })
        return _obj


