# coding: utf-8

"""
    Binance Wallet API

    OpenAPI specification for Binance exchange - Wallet API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WalletGetLocalentityDepositHistoryV1RespItem(BaseModel):
    """
    WalletGetLocalentityDepositHistoryV1RespItem
    """ # noqa: E501
    address: Optional[StrictStr] = None
    address_tag: Optional[StrictStr] = Field(default=None, alias="addressTag")
    amount: Optional[StrictStr] = None
    coin: Optional[StrictStr] = None
    confirm_times: Optional[StrictStr] = Field(default=None, alias="confirmTimes")
    deposit_status: Optional[StrictInt] = Field(default=None, alias="depositStatus")
    insert_time: Optional[StrictInt] = Field(default=None, alias="insertTime")
    network: Optional[StrictStr] = None
    questionnaire: Optional[Dict[str, Any]] = None
    require_questionnaire: Optional[StrictBool] = Field(default=None, alias="requireQuestionnaire")
    tr_id: Optional[StrictInt] = Field(default=None, alias="trId")
    tran_id: Optional[StrictInt] = Field(default=None, alias="tranId")
    transfer_type: Optional[StrictInt] = Field(default=None, alias="transferType")
    travel_rule_status: Optional[StrictInt] = Field(default=None, alias="travelRuleStatus")
    tx_id: Optional[StrictStr] = Field(default=None, alias="txId")
    unlock_confirm: Optional[StrictInt] = Field(default=None, alias="unlockConfirm")
    wallet_type: Optional[StrictInt] = Field(default=None, alias="walletType")
    __properties: ClassVar[List[str]] = ["address", "addressTag", "amount", "coin", "confirmTimes", "depositStatus", "insertTime", "network", "questionnaire", "requireQuestionnaire", "trId", "tranId", "transferType", "travelRuleStatus", "txId", "unlockConfirm", "walletType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WalletGetLocalentityDepositHistoryV1RespItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if questionnaire (nullable) is None
        # and model_fields_set contains the field
        if self.questionnaire is None and "questionnaire" in self.model_fields_set:
            _dict['questionnaire'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WalletGetLocalentityDepositHistoryV1RespItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": obj.get("address"),
            "addressTag": obj.get("addressTag"),
            "amount": obj.get("amount"),
            "coin": obj.get("coin"),
            "confirmTimes": obj.get("confirmTimes"),
            "depositStatus": obj.get("depositStatus"),
            "insertTime": obj.get("insertTime"),
            "network": obj.get("network"),
            "questionnaire": obj.get("questionnaire"),
            "requireQuestionnaire": obj.get("requireQuestionnaire"),
            "trId": obj.get("trId"),
            "tranId": obj.get("tranId"),
            "transferType": obj.get("transferType"),
            "travelRuleStatus": obj.get("travelRuleStatus"),
            "txId": obj.get("txId"),
            "unlockConfirm": obj.get("unlockConfirm"),
            "walletType": obj.get("walletType")
        })
        return _obj


